import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public class MainTest {

	protected Shell shell;
	private Display display;
	private Thread testThread;
	private Composite compChart;
	private boolean run = true;

	public static void main(String[] args) {
		try {
			MainTest window = new MainTest();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void open() {
		display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	protected void createContents() {
		shell = new Shell();
		shell.setSize(450, 300);
		shell.setText("TeeChart Test");
		shell.setLayout(new FillLayout(SWT.HORIZONTAL));

		Composite compButtons = new Composite(shell, SWT.NONE);
		compButtons.setLayout(new FillLayout(SWT.VERTICAL));

		Button btnStart = new Button(compButtons, SWT.NONE);
		btnStart.setText("Start");
		btnStart.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				run = true;

				testThread = new Thread(new Runnable() {
					@Override
					public void run() {
						while (run) {
							final TChart[] tc = new TChart[1];
							Display.getDefault().syncExec(new Runnable() {
								public void run() {
									tc[0] = new TChart(compChart, SWT.NONE);
									compChart.layout();
									System.out.println("Create");
								}
							});

							try {
								System.out.println("Wait");
								Thread.sleep(150);
							} catch (InterruptedException e) {
								e.printStackTrace();
							}

							Display.getDefault().asyncExec(new Runnable() {
								public void run() {
									System.out.println("Dispose");
									tc[0].dispose();
								}
							});

							try {
								System.out.println("Wait");
								Thread.sleep(150);
							} catch (InterruptedException e) {
								e.printStackTrace();
							}
						}
					}
				});

				testThread.start();
			}
		});

		Button btnStop = new Button(compButtons, SWT.NONE);
		btnStop.setText("Stop");
		btnStop.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if (testThread != null && !testThread.isInterrupted()) {
					run = false;
				}
			}
		});

		compChart = new Composite(shell, SWT.NONE);
		compChart.setLayout(new FillLayout(SWT.VERTICAL));
	}

}